/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
function JSON2Form(params){
	var result = [];
	for (var paramKey in params){
		result.push(paramKey+'='+params[paramKey]);
	}
	return result.join('&');
}

function convertContentType(contentType){
	if(contentType.indexOf('/') >= 0){
		return contentType.substring(contentType.indexOf('/')+1);
	}else{
		return contentType;
	}
}

function getPath(path, params){
	var jaxrsRE = /\{([^\}\/]*)\}/g;
	var nodeRE = /\:([^\:\/]*)/g;
	path = path.replace(jaxrsRE, function(match, paramName){
		if(typeof params[paramName] != 'undefined' && params[paramName] != null ){
			return params[paramName];
		}else{
			return paramName;
		}
	});
	path = path.replace(nodeRE, function(match, paramName){
		if(typeof params[paramName] != 'undefined' && params[paramName] != null ){
			return params[paramName];
		}else{
			return paramName;
		}
	});
	return path;
}

function FlightsREST_getTripFlights(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/flights/queryflights', params);
	var input = {
	    method : 'POST',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('application/json'),
	    	    body : {
	    		    	contentType : 'application/x-www-form-urlencoded; charset=UTF-8',
	    	content:JSON2Form(params)
	    		    }
	    	};
	
	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	
    return WL.Server.invokeHttp(input);;
    }

function BookingsREST_bookFlights(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	
	var path = getPath('/flightticket/service/flights/bookflights', params);
	var input = {
	    method : 'POST',
	    path : path,
	    headers: {HOST: 'localhost'},
	    //returnedContentType : convertContentType('application/json'),
	    	    body : {
	    		    	contentType : 'application/x-www-form-urlencoded; charset=UTF-8',
	    	content:JSON2Form(params)
	    		    }
	    	};
	
	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	return WL.Server.invokeHttp(input);
    }

function HotelREST_getHotelsByFlighSegmentId(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/hotel/{flightSegmentId}', params);
	var input = {
	    method : 'GET',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('application/json'),
	    	    
	    parameters: params
	    	};
	
	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
		    var result = WL.Server.invokeHttp(input);
	    if (result && !result.array){
			var searchPattern = /^response((Headers)|(Time))$|^status((Code)|(Reason))$|^totalTime$|^isSuccessful$/;
			var ret = [];
			var tmp = {};
			for (var key in result){
				if(!searchPattern.test(key)){
					tmp[key] = result[key];
				}
			}
			ret.push(tmp);
			return {"array":ret};
		}
	    
		return result;
	}

function HotelREST_bookHotel(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/hotel/booking', params);
	var input = {
	    method : 'POST',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('application/json'),
	    	    body : {
	    		    	contentType : 'application/x-www-form-urlencoded; charset=UTF-8',
	    	content:JSON2Form(params)
	    		    }
	    	};
	
	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	
		    return WL.Server.invokeHttp(input);
    }

function HotelREST_getHotelsByCity(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/hotel/bycity/{city}', params);
	var input = {
	    method : 'GET',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('application/json'),
	    	    
	    parameters: params
	    	};
	
	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	
		    var result = WL.Server.invokeHttp(input);
	    if (result && !result.array){
			var searchPattern = /^response((Headers)|(Time))$|^status((Code)|(Reason))$|^totalTime$|^isSuccessful$/;
			var ret = [];
			var tmp = {};
			for (var key in result){
				if(!searchPattern.test(key)){
					tmp[key] = result[key];
				}
			}
			ret.push(tmp);
			return {"array":ret};
		}
		return result;
	}

function NotificationREST_mobileReadNotifications(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/notification/mobileread/{customerId}', params);
	var input = {
	    method : 'GET',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('application/json'),

	    parameters: params
	    	};

	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	
	var result = WL.Server.invokeHttp(input);
	if (result && !result.array){
		var searchPattern = /^response((Headers)|(Time))$|^status((Code)|(Reason))$|^totalTime$|^isSuccessful$/;
		var ret = [];
		var tmp = {};
		for (var key in result){
			if(!searchPattern.test(key)){
				tmp[key] = result[key];
			}
		}
		ret.push(tmp);
		return {"array":ret};
	}
	return result;
}

function NotificationREST_deleteNotification(params, cookies) {
	//convert params to object if it is a string
	if(typeof params === "string"){
		params = JSON.parse(params);
	}
	var path = getPath('/flightticket/service/notification/{notificationId}', params);
	var input = {
	    method : 'DELETE',
	    path : path,
	    headers: {HOST: 'localhost'},
	    returnedContentType : convertContentType('text/plain'),
	    	    body : {
	    		    	contentType : 'application/json; charset=UTF-8',
	    	content:JSON.stringify(params)
	    		    }
	    	};

	if(typeof cookies !== "undefined"){
		input.cookies = cookies;
	}
	
	return WL.Server.invokeHttp(input);
}