/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/**
 *  WL.Server.invokeHttp(parameters) accepts the following json object as an argument:
 *  
 *  {
 *  	// Mandatory 
 *  	method : 'get' , 'post', 'delete' , 'put' or 'head' 
 *  	path: value,
 *  	
 *  	// Optional 
 *  	returnedContentType: any known mime-type or one of "json", "css", "csv", "javascript", "plain", "xml", "html"  
 *  	returnedContentEncoding : 'encoding', 
 *  	parameters: {name1: value1, ... }, 
 *  	headers: {name1: value1, ... }, 
 *  	cookies: {name1: value1, ... }, 
 *  	body: { 
 *  		contentType: 'text/xml; charset=utf-8' or similar value, 
 *  		content: stringValue 
 *  	}, 
 *  	transformation: { 
 *  		type: 'default', or 'xslFile', 
 *  		xslFile: fileName 
 *  	} 
 *  } 
 */

WL.Server.createEventSource({
	name : 'FTEventSource',
	onDeviceSubscribe: 'deviceSubscribeFunc',
	onDeviceUnsubscribe: 'deviceUnsubscribeFunc',
	securityTest: 'FlightTicket-strong-mobile-securityTest'
});

function deviceSubscribeFunc(userSubscription, deviceSubscription) {
	WL.Logger.error(">> deviceSubscribeFunc");
}

function deviceUnsubscribeFunc(userSubscription, deviceSubscription) {
	WL.Logger.error(">> deviceUnsubscribeFunc");
}

function submitNotification(userId, notificationText) {
	if (!userId)
		userId = "DD";

	if (!notificationText) {
		notificationText = "auto";
	}

	var userSubscription = WL.Server.getUserNotificationSubscription(
			'FTPushAdapter.FTEventSource', userId);

	if (userSubscription == null) {
		WL.Logger.error("No subscription found for user :: " + userId);
		return;
	}

	WL.Logger.error("sendNotificationOTA >> userId :: " + userId + ", text :: "
			+ notificationText);

	WL.Server.notifyAllDevices(userSubscription, {
		badge : 1,
		sound : "",
		activateButtonLabel : "ClickMe",
		alert : notificationText,
		payload : {
			accId : "123"
		}
	});
}