/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

// Worklight comes with the jQuery framework bundled inside. If you do not want to use it, please comment out the line below.
window.$ = WLJQ;
window.jq = jQuery.noConflict();
window.ft = {};
window.ft.$activeLinks = [];

window.ft.usersLoginToServer = {}; // Used to support offline, WL.Client.isUserAuthenticated() doesn't work?
window.ft.userProfiles = {
'demo': {
		name: 'demo',
		mobile: '123456789',
		email: 'demo@demo.com',
		cardInfo: {
			identityCard: '362329198511190099',
			passport: 'G12345678',
			other: 'demo'
		},
		passengerInfo: {
			type: 'adult',
			certType: 'identityCard',
			cardNo: '362329198511190099',
			insurance: 'no'
		}
	}
};

window.RECENT_PASSENGER_KEY = 'RECENT_PASSENGER_KEY';
window.RECENT_CONTACT_KEY = 'RECENT_CONTACT_KEY';
window.PUSH_SUB_KEY = 'PUSH_SUB_KEY';
window.CABIN_CLASS = {
	'ECONOMY': 'Economy',
	'BUSINESS': 'Business',
	'FIRST': 'First'
};

window.DAYS_OF_WEEK = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
window.MONTHS_OF_YEAR = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
window.DAYS_OF_WEEK_SHORT = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
window.MONTHS_OF_YEAR_SHORT = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

window.CERTIFICATE_TYPE = {
	'identityCard': 'Identity Card',
	'passport': 'Passport',
	'other': 'Other'
};

Date.prototype.format = function(format) {
    var o = {
    	"M+" : this.getMonth()+1, //month
    	"d+" : this.getDate(),    //day
    	"h+" : this.getHours(),   //hour
    	"m+" : this.getMinutes(), //minute
    	"s+" : this.getSeconds(), //second
    	"q+" : Math.floor((this.getMonth()+3)/3),  //quarter
    	"S" : this.getMilliseconds() //millisecond
    };
    if(/(y+)/.test(format)) {
    	format=format.replace(RegExp.$1,
    		(this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }
	for(var k in o) {
		if(new RegExp("("+ k +")").test(format)) {
			format = format.replace(RegExp.$1, 
				RegExp.$1.length==1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		}
	}
	return format;
};

(function($) {
	window.wait = function(sec, callback) {
		var count = 0;
		var n = sec;
		(function _wait() {
		  setTimeout(function() {
		    if (count++ < n) {
		      _wait();
		    } else {
		    	callback();
		    }
		  }, 1000);
		})();
	};
	
	window.isIOS = function() {
		return navigator.userAgent.match(/(iPhone|iPod|iPad)/i);
	};
	
	window.getItemInLS = function(key) {
        return JSON.parse(window.localStorage.getItem(key) || '{}');
    };
	
    window.setItemInLS = function(key, value) {
        window.localStorage.setItem(key, value);
    };
    
    // initial the JSON store
    window.initJS = function() {
    	var searchFields = { 'id': 'string', 'userid': 'string' };
    	
    	var orderJSOpts = {
    		onSuccess: function() {
    			console.log('JSONStore: orders initialized.');
    		},
    		onFailure: failureJS
        };
    	window.ft.orderJS = WL.JSONStore.initCollection('orders', searchFields, orderJSOpts);
    };
    
    window.failureJS = function(err) {
    	console.log('JSON store operation failed: ' + err);
    };
	
	window.selectcheckboxradio = function(c, val) {
		$(c).find('.ui-icon-radio-on').removeClass('ui-icon-radio-on')
			.addClass('ui-icon-radio-off').closest('label').removeClass('ui-radio-on');
		
		var $label = $(c).find('[value=' + val + ']').next('label');
		$label.addClass('ui-radio-on').find('.ui-btn-inner .ui-icon')
			.addClass('ui-icon-radio-on').removeClass('ui-icon-radio-off');
		return $label.text();
	};
	
	window.addActiveEffect = function(sel, isListItem, isPopup) {
		var $target = $(sel);
		if(isListItem) {
			$target = $target.closest('li');
		}
		$target.on('vmousedown', function() {
			if(isListItem && !isPopup) {
				window.ft.$activeLinks.push($target);
				$(this).addClass('ui-btn-active');
			} else {
				$(this).addClass('ui-btn-down-' + $(this).attr('data-theme'));
			}
		});
		if(!isListItem) {
			$target.on('vmouseup', function() {
				$(this).removeClass('ui-btn-down-' + $(this).attr('data-theme'));
			});
		}
	};
	
	window.linkBD = function(sel, href, options) {
		var opts = {
			prefetch: false,
			activeEffect: true,
			isListItem: false, 
			isPopup: false,
			onBeforeChange: function() {},
			transOpts : {
			}
		};
		$.extend(opts, options);
		
		if(opts.prefetch && !opts.isPopup) {
			$.mobile.loadPage(href);
		}
		
		if(opts.activeEffect) {
			addActiveEffect(sel, opts.isListItem, opts.isPopup);
		}
		
		$(sel).bind('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var ret = $.proxy(opts.onBeforeChange, this)();
			if(ret === false) {
				return;
			}
			
			if(!opts.isPopup) {
				$.mobile.changePage(href, opts.transOpts);
			} else {
				$(href).popup("open", {
					transition: (isIOS() ? 'pop' : 'none'),
					positionTo: '#' + $(this).attr('id')
				});
			}
		});
		
		if(opts.isPopup) {
			$(href).bind('popupafterclose', function() {
				var $target = $(sel);
				if(opts.isListItem) {
					$target = $target.closest('li');
				}
				$target.removeClass('ui-btn-active');
			});
		}
	};
	
	$(document).on('tap', '.backBtn', function(e) {
		e.stopImmediatePropagation();
		e.preventDefault();
		var href = $(this).attr('href');
		if(href) {
			$.mobile.changePage(href, {
				reverse: true
			});
		} else {
			if(('hotelDetailsPage' ==jq.mobile.activePage.attr('id')) && window.ft.isFromPopup) {
				$.mobile.changePage('hotelSelect.html');
			}else{
				history.back();
			}
		}
	}).on('tap', '.home', function(e) {
		e.stopImmediatePropagation();
		e.preventDefault();
		$.mobile.changePage($('#mainPage'), {
			transition: (isIOS() ? 'slidefade' : 'none'),
			reverse: true
		});
	}).on('tap', '.logout', function(e) {
		e.stopImmediatePropagation();
		e.preventDefault();
		WL.Device.getNetworkInfo(function(netInfo) {
			if(netInfo.isNetworkConnected == 'true' && window.ft.userId) {
				WL.Client.logout('FTRealm');
				window.ft.usersLoginToServer[window.ft.userId] = false;
			}
			window.ft.userId = '';
			$(document)
				.unbind(WL.Events.WORKLIGHT_IS_CONNECTED)
				.unbind(WL.Events.WORKLIGHT_IS_DISCONNECTED);
			busy.show();
			$('#password').val('');
			$.mobile.changePage($('#loginPage'), {
				transition: (isIOS() ? 'slidefade' : 'none'),
				reverse: true
			});
			busy.hide();
		});
	}).on('tap', '.social-share', function(e) {
		e.stopImmediatePropagation();
		e.preventDefault();
		$.mobile.changePage($('#socialSharePage'));
	}).on('vmousedown', '.backBtn,.home,.logout', function(e) {
		$(this).addClass('ui-btn-down-b');
	}).on('vmouseup', '.backBtn,.home,.logout', function(e) {
		$(this).removeClass('ui-btn-down-b');
	});
	
	function cleanActiveEffect() {
		$.each(window.ft.$activeLinks, function(i, $link) {
			$link.removeClass('ui-btn-active');
		});
		window.ft.$activeLinks = [];
	};
	
	$(document).on('tap', '.loginBtn', function(e) {
		e.stopImmediatePropagation();
		e.preventDefault();
		var username = $(this).parents('fieldset').find('.username').val();
		var password = $(this).parents('fieldset').find('.password').val();
		doLogin(username, password);
	}).on('vmousedown', '.loginBtn', function(e) {
		$(this).addClass('ui-btn-active');
		window.ft.$activeLinks.push($(this));
	}).on('pagehide', function(event, ui) {
		cleanActiveEffect();
	});
	
	$("#loginPage").live("pageinit", function() {
		$.mobile.defaultHomeScroll = 0;
//		$.mobile.buttonMarkup.hoverDelay = 0;
		
		$.mobile.loadPage('views/main.html');
		$.mobile.loadPage('views/notification.html');
		$.mobile.loadPage('views/socialShare.html');
		
		$("#mainloginBtn").live("tap", function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			var username = $('#uname').val();
			var password = $('#pwd').val();
			doLogin(username,password);
		});
	});
})(jQuery);

function wlCommonInit() {
	initJS(); // initial JSON store for data-sync
}
