/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
/*
 *	This piece of code was added as a part of upgrading your application 
 *	to a new authentication API introduced in Worklight 5.0.0.3
 *		
 *	Authenticator object that was used previosly is deprecated.
 *	New challenge handler APIs are serving as a wrapper for original Authenticator object.
 *	To learn more about challenge handler APIs please refer to Worklight documentation.
 *
 */

// ----------------- Challenge handler start -----------------
var challengeHandler1 = WL.Client.createChallengeHandler("FTRealm");

challengeHandler1.isCustomResponse = function(response){
	if (!response || !response.responseJSON	|| response.responseText === null) {
		return false;
	}
	if (typeof(response.responseJSON.authRequired) !== 'undefined'){
		return true;
	} else {
		return false;
	}
};

challengeHandler1.handleChallenge = function(response){
	var authRequired = response.responseJSON.authRequired;
	
	if (authRequired === true){
//		if (response.responseJSON.errorMessage)
//			$('#errorMsg').val(response.responseJSON.errorMessage);
//		$.mobile.changePage('#login-page');
//		$("#AppBody").hide();
//		$("#AuthBody").show();

		if (response.responseJSON.errorMessage)
	    	alert(response.responseJSON.errorMessage);
		
	}else if (authRequired === false){
		//$.mobile.changePage('#notification');
//		$("#AppBody").show();
//		$("#AuthBody").hide();
		
		jq.mobile.changePage(jq('#mainPage'));
		
		window.ft.usersLoginToServer[window.ft.loginName] = true;
		window.ft.sessionid = response.responseJSON.sessionid;
		window.ft.userId = window.ft.loginName;
		window.ft.cookies = {loggedinuser: window.ft.userId ,sessionid:window.ft.sessionid};
		
//		alert(WL.Client.Push.isSubscribed('FTPush'));
		WL.Client.Push.__updateSubscribedEventSources({'FTPush':{'alias':'FTPush'}});
//		alert(WL.Client.Push.__hasPendings());
//		alert(WL.Client.Push.isSubscribed('FTPush'));
		if(WL.Client.Push.__hasPendings()){
			WL.Client.Push.__dispatchPendings();
		}
		
		var pushSubUsers = getItemInLS(PUSH_SUB_KEY);
		if(typeof(pushSubUsers) === 'string') {
			pushSubUsers = JSON.parse(pushSubUsers);
		}
		if(!$.isArray(pushSubUsers)) {
			pushSubUsers = [];
		}
		if($.inArray(window.ft.userId, pushSubUsers) < 0) {
			if(confirm('Do you allow FlightTicket to send notification to you?')) {
				WL.Client.Push.subscribe('FTPush', {
					onSuccess: function() {
						pushSubUsers.push(window.ft.userId);
						setItemInLS(PUSH_SUB_KEY, JSON.stringify(pushSubUsers));
						alert('Subscribe success');
					},
					onFailure: function() {
						alert('Subscribe failure');
					}
				});
			}
		}
//		cordova.exec("Push.dispatch", 'WL.Client.Push.__onmessage');
//		challengeHandler.submitSuccess();
//		WL.Client.Push.subscribe('FTPush', {});
	}
};
// ----------------- Challenge handler end -----------------

window.busy = new WL.BusyIndicator('content', { duration: 1 });

function openCacheFailure(status) {
	WL.Logger.debug('Open Encrypted Cache failed: ' + status);
	busy.hide();
}
function writeEncCache(key, value, onSuccess) {
	busy.show();
	WL.EncryptedCache.open('ENCRYPT_KEY', true, function(status) {
		WL.EncryptedCache.write(key, value, function() {
			if($.isFunction(onSuccess)) {
				onSuccess();
			}
			WL.EncryptedCache.close();
			busy.hide();
		}, function(status) {
			alert("Write Encrypted Cache failed. error code= " + status);
		});
	}, openCacheFailure);
}
function readEncCache(key, onSuccess) {
	busy.show();
	WL.EncryptedCache.open('ENCRYPT_KEY', true, function(status) {
		// if in offline mode, check username and password from Encrypted Cache
		WL.EncryptedCache.read(key, function(value) {
			if($.isFunction(onSuccess)) {
				onSuccess(value);
			}
			WL.EncryptedCache.close();
			busy.hide();
		}, function(status) {
			alert("Read Encrypted Cache failed. error code= " + status);
		});
	}, openCacheFailure);
}

window.doLogin = function(username, password) {
    window.ft.loginName = username;
//	var USERNAME_INPUT_ID = '#username';
//	var PASSWORD_INPUT_ID = '#password';
	
//	var username = $(USERNAME_INPUT_ID).val();
//	var password = $(PASSWORD_INPUT_ID).val();
	
	if(!username || !password) {
		alert("Username and password cannot be empty!");
        return;
	}
	
	WL.Device.getNetworkInfo(function(netInfo) {
		var isNetworkConnected = (netInfo.isNetworkConnected == 'true');
		function loginSuccess() {
//			$('#AppBody').show();
//			$('#AuthBody').hide();
			
			jq.mobile.changePage(jq('#mainPage'));
			
			window.ft.userId = username;
			
//			jq('.login', jq.mobile.activePage).popup('close');
//			
//			setTimeout(function() {
//				window.ft.userId = username;
//				var nextPage = window.ft.nextPage || $('#mainPage');
//				jq.mobile.changePage(nextPage);
//				window.ft.nextPage = '';
//				if(isNetworkConnected) {
//					connectDetected();
//				}
//			}, 500);
		};
		if(!isNetworkConnected || window.ft.usersLoginToServer[username]) {
			readEncCache(username, function(cachedPassword) {
				if(password != cachedPassword) {
					alert('Invalid username or password!');
				} else {
					loginSuccess();
				}
			});
		} else {

			var invocationData = {
				adapter : "LoginAdapter",
				procedure : "login",
				parameters : [ username, password ]
			};
//			WL.Client.invokeProcedure(invocationData, {
//				onSuccess: function(resp) {
//					window.ft.usersLoginToServer[username] = true;
//					window.ft.sessionid = resp.invocationResult.sessionid;
//					writeEncCache(username, password);
//					loginSuccess();
//				},
//				onFailure: function(resp) {
//					console.log("invoke FTAdapter failed: " + resp);
//				}
//			});
			challengeHandler1.submitAdapterAuthentication(invocationData);
		
		}
	});
};

var Authenticator = function () {
	return {
		init : function() {
		},

		isLoginFormResponse : function(response) {
			if (!response || !response.responseJSON	|| response.responseText === null) {
				return false;
			}
			return response.responseJSON.authRequired;
		},

		onBeforeLogin : function(response, username, onSubmit, onCancel) {
			if (response.responseJSON && response.responseJSON.errorMessage) {
				alert(response.responseJSON.errorMessage);
			}
		},

		onShowLogin : function() {
//			$.mobile.hidePageLoadingMsg();
//			$.mobile.changePage(jq('#loginView'));
		},

		onHideLogin : function() {
//			$.mobile.hidePageLoadingMsg();
		}
	};
}();
