/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	$("#boardingPassPage").live("pagebeforeshow", function() {
		var $this = $(this);
		var outboundFlight = window.ft.order.details.outboundFlight;
		
		$('.boarding-pass .flight-number', $this).text('Flight ' + outboundFlight.flightSegmentId);
		var departDate = new Date(outboundFlight.departDate);
		$.each({
			'day': departDate.getDate(),
			'month': MONTHS_OF_YEAR_SHORT[departDate.getMonth()],
			'year': departDate.getFullYear()
		}, function(prop, value) {
			$('.boarding-pass .departDate .' + prop, $this).text(value);
		});
		
		var departTime = new Date(
			new Date(outboundFlight.departDate).format('yyyy/MM/dd') + ' ' + outboundFlight.departTime);
		outboundFlight.boardingTime = new Date(departTime.getTime() - 30 * 60 * 1000).format('hh:mm');
		$.each(['departAP', 'boardingTime', 'destAP', 'departTime'], function(i, prop) {
			$('.boarding-pass .' + prop, $this).text(outboundFlight[prop]);
		});
		
		var passengerNames = '';
		$.each(window.ft.order.details.passengers, function(i, p) {
			if(i > 0) {
				passengerNames += ', ';
			}
			passengerNames += p.name;
		});
		$('.passenger-name', $this).text(passengerNames);
		
		$('#boardingPassQRcode').html('').qrcode({
			width: 120, height: 120,
			text: 'Seat Number:' + window.ft.seatNo
//			text: CERTIFICATE_TYPE[profile.passengerInfo.certType] + ':' + 
//				profile.passengerInfo.cardNo + ',Seat Number:' + window.ft.seatNo
		});
	});
	
	$("#boardingPassPage").live("pageinit", function() {
		$('.boarding-pass .header .notification', $(this)).on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			window.ft.messageFilter = window.ft.order.details.outboundFlight.flightSegmentId;
			$.mobile.changePage($('#notification-page'));
		});
	});
})(jq);