/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var firstTime = true;
	
	function renderPassengerList() {
		var $templete = $('#passengerList .templete').remove();
		var $passengerList = $('#passengerList').html('');
		var $itemPassengerTpl = $templete.filter('.passenger')
			.clone().removeClass('templete').show();
		$.each(window.ft.passengerList, function(i, passenger) {
			var $itemPassenger = $itemPassengerTpl.clone()
				.attr('data-passenger-index', i).appendTo($passengerList);
			$('.nameAndType', $itemPassenger)
				.text(passenger.name + ' (' + passenger.type + ')');
			$('.certificate', $itemPassenger)
				.text(CERTIFICATE_TYPE[passenger.certType] + ': ' + passenger.cardNo);
			$('.insurance', $itemPassenger).text(passenger.insurance);
		});
		$passengerList.listview('refresh').append($templete);
	}
	
	function renderContactList() {
		var $templete = $('#contactList .templete').remove();
		var $contactList = $('#contactList').html('');
		var $itemContactTpl = $templete.filter('.contact')
			.clone().removeClass('templete').show();
		$.each(window.ft.contactList, function(i, contact) {
			var $itemContact = $itemContactTpl.clone()
				.attr('data-contact-index', i).appendTo($contactList);
			$('.name', $itemContact).text(contact.name);
			$('.mobile', $itemContact).text('Mobile: ' + contact.mobile);
			$('.email', $itemContact).text('Email: ' + contact.email);
		});
		$contactList.listview('refresh').append($templete);
	}
	
//	function bookTicket() {
//		var orderInfo = {
//			userId: window.ft.userId,
//			details: JSON.stringify({
//				outboundFlight: window.ft.outboundFlight || {},
//				returnFlight: window.ft.returnFlight || {},
//				isRoundTrip: window.ft.isRoundTrip,
//				passengers: window.ft.passengerList,
//				contacts: window.ft.contactList
//			})
//		};
//		var invocationData = {
//			adapter : "FTAdapter",
//			procedure : "createOrder",
//			parameters : [orderInfo]
//		};
//		WL.Client.invokeProcedure(invocationData, {
//			onSuccess: function(resp) {
//				window.ft.orderInfo = resp.invocationResult;
//				window.ft.orderJS.store(resp.invocationResult);
//				$.mobile.changePage("orderResult.html");
//			}
//		});
//	}
	
	$("#bookTicketPage").live("pagebeforeshow", function() {
		$('#bookTicketPage .backBtn').attr('href', 
			(window.ft.isRoundTrip ? 'selectReturnFlight.html' : 'selectOutboundFlight.html'));
		
		$('#OFInfoBT .departDate').text(
				(window.ft.isRoundTrip ? 'Outbound Flight' : 'One Way') + 
				', ' + new Date(window.ft.outboundFlight.departDate).format("yyyy-MM-dd"));
		$.each(['departAP', 'departTime', 'destAP', 'reachTime','flightSegmentId'], function(i, prop) {
			$('#OFInfoBT .' + prop).text(window.ft.outboundFlight[prop]);
		});
		
		if(window.ft.isRoundTrip) {
			$('#RFInfoBT .departDate').text(
				'Return Flight, ' + new Date(window.ft.returnFlight.departDate).format("yyyy-MM-dd"));
			$.each(['departAP', 'departTime', 'destAP', 'reachTime','flightSegmentId'], function(i, prop) {
				$('#RFInfoBT .' + prop).text(window.ft.returnFlight[prop]);
			});
			$('#RFInfoBT').show();
		} else {
			$('#RFInfoBT').hide();
		}
		
		$('#passengerList').on('tap', '.passenger', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-passenger-index');
			window.ft.passenger = window.ft.passengerList[idx];
			window.ft.isEditPassenger = true;
			$.mobile.changePage('passengerInfo.html');
		}).on('vmousedown', '.passenger', function(e) {
			var $target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.passenger', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		$('#contactList').on('tap', '.contact', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-contact-index');
			window.ft.contact = window.ft.contactList[idx];
			window.ft.isEditContact = true;
			$.mobile.changePage('contactInfo.html');
		}).on('vmousedown', '.contact', function(e) {
			var $target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.contact', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		linkBD('#bookTicketPage .add-passenger', 'passengerInfo.html', {
			onBeforeChange: function() {
				window.ft.isEditPassenger = false;
			}
		});
		linkBD('#addContact', 'contactInfo.html', {
			onBeforeChange: function() {
				window.ft.isEditContact = false;
			}
		});
//		$('#bookBtn .ui-btn-text').text(
//			window.ft.userId ? 'Order Now' : 'Login To Order');
		
		if(firstTime) {
			firstTime = false;
			var p = window.ft.userProfiles[window.ft.userId || 'demo'];
			window.ft.passengerList.push({
				name: p.name,
				type: p.passengerInfo.type,
				certType: p.passengerInfo.certType,
				cardNo: p.passengerInfo.cardNo,
				insurance: p.passengerInfo.insurance
			});
			window.ft.contactList.push({
				name: p.name,
				mobile: p.mobile,
				email: p.email
			});
		}
		
		renderPassengerList();
		renderContactList();
	});
	
	$("#bookTicketPage").live("pageinit", function() {
		if(!window.ft.passengerList) {
			window.ft.passengerList = [];
		}
		if(!window.ft.contactList) {
			window.ft.contactList = [];
		}
		
		linkBD('#bookBtn', 'orderResult.html');
	});
})(jq);

