
/* JavaScript content from js/hotelAsist.js in folder common */
/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	window.ft.isFromSearchPage = false;
	var daysOfWeekShort = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
	var monthsOfYear = ['January', 'February', 'March', 'April ', 'May', 'June', 'July', 'August', 'September ', 'October', 'November', 'December'];
	var orderList = [];
	var orderLength = 0;
	var currentOrder = null;
	var currentOrderIndex = 0;
	
	function setDate(date) {
		date = new Date(Date.parse(date.replace(/-/g, '/')));
		var result = daysOfWeekShort[date.getDay()]+" "+date.getDate()+" "+monthsOfYear[date.getMonth()]+","+date.getFullYear();
		return result;
	}
	
	function renderHotelInfo(data){
		var hotelResults = window.ft.hotelList = data;
		$('#hotelAssistList').html($('#hotelAssistList .template'));
		$.each(hotelResults, function(i, hotel) {
			var $tempItem = $('#hotelAssistList .template').clone();
			$('.hotelImg', $tempItem).attr('src','../images/' + hotel['imgUrls'][0]);
			//$('.hotelImg', $tempItem).attr('src','../images/Shangri-La_Hotel.jpg');
			var $starRating = $('.starRating',$tempItem).html('');
			for ( var i = 0; i < hotel.star; i++) {
				$starRating.append('<span class="smallstar">');
			}
			if(!hotel.booked){
				$('.bookBefore', $tempItem).hide();
			}
			if(!hotel.hasWifi){
				$('.wifi', $tempItem).hide();
			}
			if(!hotel.hasGym){
				$('.gym', $tempItem).hide();
			}
			if(!hotel.favorite){
				$('.favorite', $tempItem).hide();
			}
			var props = ['name', 'price','rating'];
			$.each(props, function(i, prop) {
					switch (prop) {
					case 'name':
						hotel[prop] = hotel[prop].split(" ", 1)
								+ " hotel";
						break;
					case 'price':
						hotel[prop] = '$' + hotel[prop].amount;
						break;
					}
					$('.' + prop, $tempItem).text(hotel[prop]);
			});
			$tempItem.removeClass('template').attr(
					'hotel-index', i).attr('hotelId',
					hotel.id).appendTo('#hotelAssistList')
					.show();
		});
		$('#hotelAssistList').listview('refresh');
	}
	
	function getHotelInfo(para, isByFlight){
		var procedure = isByFlight ? 'HotelREST_getHotelsByFlighSegmentId':'HotelREST_getHotelsByCity';
		var para = isByFlight ? {flightSegmentId:para} :  {city:para};
		var invocationData = {
				adapter : "FTAdapter",
				procedure : procedure,
				parameters : [para,window.ft.cookies]
			};
		WL.Client.invokeProcedure(invocationData, {
			onSuccess: function(resp) {
				if (resp.invocationResult.array[0].result) {
					renderHotelInfo(resp.invocationResult.array[0].result);
				}else{
					$('#hotelAssistList').html($('#hotelAssistList .template'));
				}
			},
			onFailure: function(resp) {
				console.log("invoke FTAdapter failed: " + resp);
			}
		});
	}
	
	function renderFlightInfo(){
		//alert(JSON.stringify(currentOrder));
		var flightInfo = {};
		flightInfo.flightSegId = currentOrder.outboundFlight.flightSegmentId;
		flightInfo.departDate= setDate(new Date(currentOrder.outboundFlight.departDate).format('MM/dd/yyyy'));
		flightInfo.departAP = currentOrder.outboundFlight.departAP;
		flightInfo.destAP = currentOrder.outboundFlight.destAP;
		//alert(flightSegId+","+departDate+","+departAP+","+destAP);
		var props = ['flightSegId', 'departDate','departAP', 'destAP'];
		$.each(props, function(i, prop) {
			$('#bookedFlight .' + prop).text(flightInfo[prop]);
		});
		return flightInfo.flightSegId;
	}
	
	$("#hotelAssist").live("pagebeforeshow", function() {
		if (window.ft.isFromSearchPage){
			//fake flight data
			$('#bookedFlight').hide();
			getHotelInfo(window.ft.searchCity, false);
		} else {
			$('#bookedFlight').show();
			//alert("bookedHotel");
			window.ft.orderJS.find(
				{
					'userid' : window.ft.userId
				},
				{
					onSuccess : function(orders) {
						orderList = orders || [];
						orderList.sort(function(a, b) {
							a = a.json;
							b = b.json;
							return (a.createdTime > b.createdTime ? -1 : 1);
						});
						orderLength = orderList.length;
						if (orderLength > 0) {
							currentOrder = JSON.parse(orderList[0].json.details);
							var flightSegId = renderFlightInfo();
							getHotelInfo(flightSegId, true);
						}
						//alert(currentOrder.outboundFlight.flightSegmentId);
					},
					onFailure : function(err) {
						console.log('falied to search orderJS.');
					}
				});
		}
		
	});
	
	$("#hotelAssist").live("pageinit", function() {
		$('#preFlight').on('click', function() {
			currentOrderIndex = (currentOrderIndex < 1 ) ? (orderLength - 1) : (currentOrderIndex - 1);
			currentOrder = JSON.parse(orderList[currentOrderIndex].json.details);
			var flightSegId = renderFlightInfo();
			getHotelInfo(flightSegId, true);
		});
		
		$('#nextFlight').on('click', function() {
			currentOrderIndex = (currentOrderIndex > orderLength - 2 ) ? 0 : (currentOrderIndex + 1);
			currentOrder = JSON.parse(orderList[currentOrderIndex].json.details);
			var flightSegId = renderFlightInfo();
			getHotelInfo(flightSegId, true);
		});
		
		$('#queryHotelbtn').on('click', function() {
			$.mobile.changePage('hotelSearch.html');
		});
		
		$('#hotelAssistList').on('tap', '.hotelInfo', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			//alert($(this).attr('hotelId'));
			window.ft.hotelDetailId = $(this).attr('hotelId');
			window.ft.isFromPopup = false;
			$.mobile.changePage('hotelDetails.html');
			$(this).removeClass('ui-btn-active');
		}).on('vmousedown', '.hotelInfo', function(e) {
			$(this).addClass('ui-btn-active');
		}).on('vmousemove', '.hotelInfo', function(e) {
			$(this).removeClass('ui-btn-active');
		});
	});
})(jq);