/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var daysOfWeekShort = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
	var monthsOfYearShort = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
	window.ft.roomType = window.ft.roomType?window.ft.roomType:"DOUBLE_ROOM";
	window.ft.roomNum = window.ft.roomNum?window.ft.roomNum:"1";
	
	function setDate(date, prefix) {
		date = new Date(Date.parse(date.replace(/-/g, '/')));
		if('checkin'==prefix) {
			window.ft.checkinDate = date.getTime();
		} else if('checkout'==prefix) {
			window.ft.checkoutDate = date.getTime();
		}
		
		$('#' + prefix + 'Text').text(daysOfWeekShort[date.getDay()]+" "+date.getDate()+","+monthsOfYearShort[date.getMonth()]);
	}
	
	function updateTotalNight() {
		if((window.ft.checkinDate)&&(window.ft.checkoutDate)&&(window.ft.checkoutDate > window.ft.checkinDate)){
			var days = Math.ceil((window.ft.checkoutDate - window.ft.checkinDate)/86400000);
			$('#totalDays').text(days);
		}else{
			$('#totalDays').text(0);
		}
		updateTotalPrice();
	}
	
	function updateTotalPrice() {
		var hotelDetails = window.ft.hotelDetails;
		var roomPrice = 0;
		$.each(hotelDetails.rooms, function(i, room) {
			if(room.type == window.ft.roomType){
				roomPrice = room.price.amount;
			}
		});
		var totalPrice = roomPrice * parseInt($('#totalDays').text()) * parseInt($('#roomNumText').text());
		$('#totalPrice').text(totalPrice);
	}
	
	$("#hotelBookingPage").live("pagebeforeshow", function() {
		//alert("pagebeforeshow");
		var hotelDetails = window.ft.hotelDetails;
		$('#hotelBookingPage .name').text(hotelDetails.name);
		
		var $starRating = $('#hotelBookingPage .starRating').html('');
		for(var i = 0; i < hotelDetails.starRating; i++) {
			$starRating.append('<span class="star">');
		}
		
		$('#hotelBookingPage .address').text(hotelDetails.address);
	});
	
	$("#hotelBookingPage").live("pageinit", function() {
		var today = new Date().format('MM/dd/yyyy');
		var dataPrefixes = ['checkin', 'checkout'];
		$.each(dataPrefixes, function(i, prefix) {
			setDate(today, prefix);
			$('#'+ prefix +'Link').on('tap', function(e) {
				e.stopImmediatePropagation();
				e.preventDefault();
				$('#'+ prefix +'Date').mobiscroll('show');
			});
			$('#'+ prefix +'Date').on('change', function() {
				var val = $(this).val();
				if(val) {
					setDate(val, prefix);
					updateTotalNight();
				}
			}).mobiscroll().date({
				theme: 'ios',
				display: 'bottom',
				mode: 'scroller',
				dateOrder: 'mmD ddyy',
		    });
		});
		var roomPrefixes = ['roomType', 'roomNum'];
		$.each(roomPrefixes, function(i, prefix) {
			linkBD('#'+prefix, '#'+ prefix +'Opts', { 
				isPopup: true
			});
			$('input[name='+ prefix +']').on('click', function(e) {
				window.ft[prefix] = $(this).val();
				$('#' + prefix + 'Text').text($(this).next('label').text());
				$('#'+ prefix +'Opts').popup("close");
				updateTotalPrice();
			});
		});
		
		$('#bookNowBtn').on('click', function() {
			var bookHotelInfo = {
				customerId: window.ft.userId,
				hotelId: window.ft.hotelDetailId,
				hotelName : window.ft.hotelDetails.name,
				roomType: window.ft.roomType ? window.ft.roomType : "DOUBLE_ROOM",
				checkInDate : window.ft.checkinDate ? window.ft.checkinDate : new Date().getTime(),
				checkOutDate : window.ft.checkoutDate ? window.ft.checkoutDate : new Date().getTime()
			};
			//alert(JSON.stringify(bookHotelInfo));
			var invocationData = {
					adapter : "FTAdapter",
					procedure : "HotelREST_bookHotel",
					parameters : [bookHotelInfo,window.ft.cookies]
			};
			WL.Client.invokeProcedure(invocationData, {
				onSuccess: function(resp) {
					if(resp.invocationResult){
						//alert("Hotel book success! Your booking id is: " + resp.invocationResult.result.bookingId);
						 navigator.notification.alert( 
							 "Hotel booked. We have emailed you the booking id of: " + resp.invocationResult.bookingId,
					            function(){
								 	$.mobile.changePage('main.html');
							 	 },         
					            'Book Success',           
					            'OK'                  
						 );
					}
				}
			});
		});
	});
})(jq);