/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	window.ft.isFromPopup = false;
	var hotelDetails = {
		name: 'Shangri-la',
		images: ['../images/Shangri-La_Hotel.jpg'],
		price: '$ 110',
		starRating: 5,
		vote: 4.7,
		hasWifi:true,
		hasGym:true,
		address: '...',
	};
	
	$(document).on("pagebeforeshow", '#hotelDetailsPage', function() {
		$.each(window.ft.hotelList, function(i, hotel) {
			if(hotel.id == window.ft.hotelDetailId){
				hotelDetails = window.ft.hotelDetails = {
						name: hotel.name,
						images: hotel.imgUrls,
						price: hotel.price,
						starRating: hotel.star,
						vote: hotel.rating,
						hasWifi:hotel.hasWifi,
						hasGym:hotel.hasGym,
						address: hotel.address.streetAddress,
						rooms: hotel.rooms,
						booked: hotel.booked,
						favorite: hotel.favorite
					};
			}
		});
		
		$('.title', this).text(hotelDetails.name);
		
		var $photoSlideBox = $('.photo-slide-box', this);
		$photoSlideBox.html($('.template', $photoSlideBox));
		var $indexDiv = $('<div class="index">');
		$.each(hotelDetails.images, function(i, url) {
			$('.template.photo-slide', $photoSlideBox).clone().attr('data-index', i)
				.removeClass('template').addClass(i > 0 ? 'out' : 'in')
				.appendTo($photoSlideBox).find('img').attr('src', '../images/' + url);
			$indexDiv.append(
				$('<span>').attr('data-index', i)[i > 0 ? 'removeClass' : 'addClass']('select'));
		});
		$indexDiv.appendTo($photoSlideBox);
		
		var $hotelInfo = $('.hotel-info', this);
		$('.name', $hotelInfo).text(hotelDetails.name);
		
		var $starRating = $('.starRating', $hotelInfo).html('');
		for(var i = 0; i < hotelDetails.starRating; i++) {
			$starRating.append('<span class="star">');
		}
		
		$('.price', $hotelInfo).text(hotelDetails.price);
		var facilities = ['wifi','gym','bookBefore'];
		$.each(facilities, function(i, item) {
			$('.' + item, $hotelInfo).show();
		});
		if(!hotelDetails.hasWifi){
			$('.wifi', $hotelInfo).hide();
		}
		if(!hotelDetails.hasGym){
			$('.gym', $hotelInfo).hide();
		}
		if(!hotelDetails.booked){
			$('.bookBefore', $hotelInfo).hide();
		}
		
		$('.vote', $hotelInfo).html($('<span>').text(hotelDetails.vote));
		$('.address', $hotelInfo).html($('<span>').text(hotelDetails.address));
	});
	
	$(document).on("pageinit", '#hotelDetailsPage', function() {
		var $this = $(this);
		$('.photo-slide-box', $this).on('swipeleft', '.photo-slide', function(e) {
			if($('.photo-slide', $this).length > 1) {
				var currPhotoIdx = $('.index .select', $this).attr('data-index');
				var nextPhotoIdx = (currPhotoIdx + 1) % hotelDetails.images.length;
				
				$('.photo-slide[data-index="' + currPhotoIdx + '"]', $this)
					.removeClass('in reverse').addClass('out');
				$('.photo-slide[data-index="' + nextPhotoIdx + '"]', $this)
					.removeClass('out reverse').addClass('in');
				
				$('.index span', $this).removeClass('select');
				$('.index span[data-index="' + nextPhotoIdx + '"]', $this).addClass('select');
			}
		}).on('swiperight', '.photo-slide', function() {
			var currPhotoIdx = $('.index .select', $this).attr('data-index');
			var nextPhotoIdx = currPhotoIdx - 1;
			if(nextPhotoIdx < 0) {
				nextPhotoIdx = hotelDetails.images.length - 1;
			}
			
			$('.photo-slide[data-index="' + currPhotoIdx + '"]', $this)
				.removeClass('in reverse').addClass('out reverse');
			$('.photo-slide[data-index="' + nextPhotoIdx + '"]', $this)
				.removeClass('out reverse').addClass('in reverse');
			
			$('.index span', $this).removeClass('select');
			$('.index span[data-index="' + nextPhotoIdx + '"]', $this).addClass('select');
		});
		
		$('#bookHotelBtn').on('click', function() {
			$.mobile.changePage('hotelBooking.html');
		});
	});
})(jq);