/*
 *  Licensed Materials - Property of IBM
 *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
 *  US Government Users Restricted Rights - Use, duplication or
 *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

function updateNotifications() {
    var $ = window.jq;
    
	var invocationData = {
		adapter : "FTAdapter",
		procedure : "NotificationREST_mobileReadNotifications",
		parameters : [ {customerId: window.ft.userId }, window.ft.cookies ]
	};
	WL.Client.invokeProcedure(invocationData, {
		onSuccess: function(resp) {
			//alert(JSON.stringify(resp.invocationResult.notifications));
			var notifications = resp.invocationResult.array[0].notifications;
			$('#messageList').html($('#messageList .template'));
			if(!notifications || notifications.length == 0) {
				$('#messageList .template.noMessage').show();
			} else {
				$('#messageList .template.noMessage').hide();
				notifications.sort(function(a, b) {
					return (a.timeStamp > b.timeStamp ? -1 : 1);
				});
				$.each(notifications, function(i, notification) {
					var $item = $('#messageList .template.message').clone();
					$('.messageText', $item).html(notification.message);
					$('.messageTime', $item).text(
						new Date(notification.timeStamp).format("yyyy-MM-dd hh:mm"));
					if(notification.mobileRead) {
						$('.unread', $item).removeClass('unread');							
					}
					var messageType = notification.type || '';
					$item.removeClass('template').attr({
						'msgId': notification.id,
						'message-type': messageType.toLowerCase(),
						'data-filtertext': (notification.flightSegId + ',' + $item.text())
					}).appendTo('#messageList').show();
				});
			}
			$('#messageList').listview('refresh');
			
			if(window.ft.messageFilter) {
				setTimeout(function() {
					$('#notification-page .ui-input-search input')
						.val(window.ft.messageFilter).change();
				}, 0);
			}
		},
		onFailure: function(resp) {
			console.log("invoke FTAdapter failed: " + resp);
		}
	});
}

(function($){
	$("#notification-page").live("pagebeforeshow", function() {
		updateNotifications();
	});
	
	$("#notification-page").live("pagehide", function() {
		window.ft.messageFilter = '';
		$('#notification-page .ui-input-search input').val('').change();
	});
	
	$('#notification-page').live('pageinit', function(){
		$('#notification-page #messageList').on('tap', '.message', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			var $this = $(this);
			$this.find('.unread').remove();
			$('.flight_delayed, .checkin_reminder', $this).hide();
			$this.find('.messageText').toggleClass('expand');
			if($this.find('.messageText').hasClass('expand')) {
				var messageType = $this.attr('message-type');
				if(messageType == 'flight_delayed') {
					$('.flight_delayed', $this).show();
				} else if(messageType == 'checkin_reminder') {
					$('.checkin_reminder', $this).show();
				}
			}
		}).on('tap', '.remove', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var $this = $(this);
			var invocationData = {
					adapter : "FTAdapter",
					procedure: "NotificationREST_deleteNotification",
					parameters : [ {
						notificationId : $this.closest('li').attr("msgId")
					}, window.ft.cookies]
				};
			WL.Client.invokeProcedure(invocationData, {
				onSuccess: function(resp) {
					$this.closest('li').addClass('out');
					setTimeout(function() {
						$this.closest('li').remove();
						$('#messageList').listview('refresh');
					}, 500);
				},
				onFailure: function(resp) {
					console.log("invoke FTAdapter failed: " + resp);
				}
			});
		}).on('tap', '.flight_delayed a,.checkin_reminder a', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
		});
	});
})(jq);