/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	var orderList = [];
	
	function renderOrderList() {
		var $templete = $('#orderList .templete').remove();
		var $orderList = $('#orderList').html('');
		var $itemOrderTpl = $templete.filter('.order')
			.clone().removeClass('templete').show();
		if(!orderList || orderList.length == 0) {
			$templete.appendTo($orderList).filter('.noOrders').show();
		} else {
			$.each(orderList, function(i, order) {
				order = order.json; // adjust for JSONStore.
				order.details = JSON.parse(order.details);
				var details = order.details;
				var $itemOrder = $itemOrderTpl.clone()
					.attr('data-order-index', i).appendTo($orderList);
				$('.depart-dest-airport .departAP', $itemOrder)
					.text(details.outboundFlight.departAP);
				$('.depart-dest-airport .destAP', $itemOrder)
					.text(details.outboundFlight.destAP);
				
				var departDate = new Date(details.outboundFlight.departDate);
				$.each({
					'day': departDate.getDate(),
					'month': MONTHS_OF_YEAR_SHORT[departDate.getMonth()],
					'year': departDate.getFullYear()
				}, function(prop, value) {
					$('.departDate .' + prop, $itemOrder).text(value);
				});
			});
			$orderList.listview('refresh').append($templete.hide());
		}
	}
	
	$("#orderPage").live("pagebeforeshow", function() {
		window.ft.orderJS.find({
			'userid': window.ft.userId
		}, {
			onSuccess: function(orders) {
				orderList = orders || [];
				orderList.sort(function(a, b) {
					a = a.json;
					b = b.json;
					return (a.createdTime > b.createdTime ? -1 : 1);
				});
				renderOrderList();
			}, onFailure: function(err) {
				console.log('falied to search orderJS.');
			}
		});
	});
	
	$("#orderPage").live("pageinit", function() {
		$('#orderList').on('tap', '.order', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-order-index');
			window.ft.order = orderList[idx].json;
			$.mobile.changePage(
				(window.ft.order.status == 'CHECKED-IN') ? 'boardingPass.html' : 'orderDetails.html');
		}).on('vmousedown', '.order', function(e) {
			$target = $(this).closest('li');
			$(this).addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.order', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
//		ft.util.decorateButtons("#orderPage .backBtn");
	});
})(jq);