/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderPassengerInfo(passengerList) {
		var $templete = $('#passengerInfoOD .templete').remove();
		var $passengerList = $('#passengerInfoOD').html('');
		var $itemPassengerTpl = $templete.filter('.passenger')
			.clone().removeClass('templete').show();
		$.each(passengerList, function(i, passenger) {
			var $itemPassenger = $itemPassengerTpl.clone().appendTo($passengerList);
			$('.nameAndType', $itemPassenger)
				.text(passenger.name + ' (' + passenger.type + ')');
			$('.certificate', $itemPassenger)
				.text(CERTIFICATE_TYPE[passenger.certType] + ': ' + passenger.cardNo);
			$('.insurance', $itemPassenger).text(passenger.insurance);
		});
		$passengerList.append($templete);
	}
	
	function renderContactInfo(contactList) {
		var $templete = $('#contactInfoOD .templete').remove();
		var $contactList = $('#contactInfoOD').html('');
		var $itemContactTpl = $templete.filter('.contact')
			.clone().removeClass('templete').show();
		$.each(contactList, function(i, contact) {
			var $itemContact = $itemContactTpl.clone().appendTo($contactList);
			$('.name', $itemContact).text(contact.name);
			$('.mobile', $itemContact).text('Mobile: ' + contact.mobile);
			$('.email', $itemContact).text('Email: ' + contact.email);
		});
		$contactList.append($templete);
	}
	
	$("#orderDetailsPage").live("pagebeforeshow", function() {
		var details = window.ft.order.details;
		var outboundFlight = details.outboundFlight;
		
		var $this = $(this);
		$('.flight-info .flight-number', $this).text('Flight ' + outboundFlight.flightSegmentId);
		var departDate = new Date(outboundFlight.departDate);
		$.each({
			'day': departDate.getDate(),
			'month': MONTHS_OF_YEAR_SHORT[departDate.getMonth()],
			'year': departDate.getFullYear()
		}, function(prop, value) {
			$('.flight-details .departDate .' + prop, $this).text(value);
		});
		
		$.each(['departAP', 'departTime', 'destAP', 'reachTime'], function(i, prop) {
			$('.flight-details .outbound .' + prop, $this).text(outboundFlight[prop]);
		});
		
		var passengerNames = '';
		$.each(details.passengers, function(i, p) {
			if(i > 0) {
				passengerNames += ', ';
			}
			passengerNames += p.name;
		});
		$('.passenger-name', $this).text(passengerNames);
		
		$('.checkInBtn')[window.ft.order.status == 'PAID' ? 'show' : 'hide']();
//		$('.viewBoardingPassBtn')[window.ft.order.status == 'CHECKED-IN' ? 'show' : 'hide']();
		
	});
	
	$("#orderDetailsPage").live("pageinit", function() {
		$('.flight-info .header .notification', $(this)).on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			window.ft.messageFilter = window.ft.order.details.outboundFlight.flightSegmentId;
			$.mobile.changePage($('#notification-page'));
		});
		
		linkBD('#orderDetailsPage .viewBoardingPassBtn', 'boardingPass.html');
		
		linkBD('#orderDetailsPage .checkInBtn', 'selectSeat.html');
	});
})(jq);