/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderPassengerInfo() {
		var $templete = $('#passengerInfoOR .templete').remove();
		var $passengerList = $('#passengerInfoOR').html('');
		var $itemPassengerTpl = $templete.filter('.passenger')
			.clone().removeClass('templete').show();
		$.each(window.ft.passengerList, function(i, passenger) {
			var $itemPassenger = $itemPassengerTpl.clone().appendTo($passengerList);
			$('.nameAndType', $itemPassenger)
				.text(passenger.name + ' (' + passenger.type + ')');
			$('.certificate', $itemPassenger)
				.text(CERTIFICATE_TYPE[passenger.certType] + ': ' + passenger.cardNo);
			$('.insurance', $itemPassenger).text(passenger.insurance);
		});
		$passengerList.append($templete.hide());
	}
	
	function renderContactInfo() {
		var $templete = $('#contactInfoOR .templete').remove();
		var $contactList = $('#contactInfoOR').html('');
		var $itemContactTpl = $templete.filter('.contact')
			.clone().removeClass('templete').show();
		$.each(window.ft.contactList, function(i, contact) {
			var $itemContact = $itemContactTpl.clone().appendTo($contactList);
			$('.name', $itemContact).text(contact.name);
			$('.mobile', $itemContact).text('Mobile: ' + contact.mobile);
			$('.email', $itemContact).text('Email: ' + contact.email);
		});
		$contactList.append($templete.hide());
	}
	
	$("#orderResultPage").live("pagebeforeshow", function() {
		$('#OFInfoOR .departDate').text(
				(window.ft.isRoundTrip ? 'Outbound Flight'
						: 'One Way')
						+ ', '
						+ new Date(window.ft.outboundFlight.departDate).format("yyyy-MM-dd"));
		$.each([ 'departAP', 'departTime', 'destAP', 'reachTime','flightSegmentId'],
				function(i, prop) {
					$('#OFInfoOR .' + prop).text(
							window.ft.outboundFlight[prop]);
				});
		if (window.ft.isRoundTrip) {
			$('#RFInfoOR .departDate').text(
					'Return Flight, '
							+ new Date(window.ft.returnFlight.departDate).format("yyyy-MM-dd"));
			$.each([ 'departAP', 'departTime', 'destAP',
					'reachTime','flightSegmentId'], function(i, prop) {
				$('#RFInfoOR .' + prop).text(
						window.ft.returnFlight[prop]);
			});
			$('#RFInfoOR').show();
		} else {
			$('#RFInfoOR').hide();
		}
		var totalPrice = window.ft.outboundFlight.price;
		if (window.ft.isRoundTrip) {
			totalPrice += window.ft.returnFlight.price;
		}
		$.each(window.ft.passengerList, function(i, passenger) {
			if (passenger.insurance == 'yes') {
				totalPrice += 5;
			}
		});
		$('#flightInfoOR .price').text(
				'Total Price: $' + totalPrice);
		renderPassengerInfo();
		//				renderContactInfo();
		$('#flightInfoOR').listview('refresh');
	});
	
	$("#orderResultPage").live("pageinit", function() {
//		ft.util.decorateButtons("#orderResultPage .backBtn");
		linkBD('#backToMain', $('#mainPage'), {
			transOpts: { reverse: true }
		});
		
//		linkBD('#searchHotelBtn', 'hotelSelect.html');
		
		$('#payNowBtn').on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			//busy.show();
			var cookies = {loggedinuser: window.ft.userId ,sessionid:window.ft.sessionid};
			var flightInfo = (!window.ft.isRoundTrip) ? {
				"userid":window.ft.userId,
				"toFlightId":window.ft.outboundFlight.flightId,
				"toFlightSegId":window.ft.outboundFlight.flightSegmentId,
				"oneWayFlight":true,
			} : {
				"userid":window.ft.userId,
				"toFlightId":window.ft.outboundFlight.flightId,
				"toFlightSegId":window.ft.outboundFlight.flightSegmentId,
				"retFlightId":window.ft.returnFlight.flightId,
				"retFlightSegId":window.ft.returnFlight.flightSegmentId,
				"oneWayFlight":false,
		   };
			var invocationData = {
				adapter : "FTAdapter",
				procedure : "BookingsREST_bookFlights",
				parameters : [flightInfo,cookies]
			};
			WL.Client.invokeProcedure(invocationData, {
				onSuccess: function(resp) {
					setTimeout(function(){
						busy.hide();
					}, 0);
					if (resp.invocationResult.departBookingId) {
						window.ft.orderInfo = {
							id: resp.invocationResult.departBookingId,
							userId: window.ft.userId,
							details: JSON.stringify({
								outboundFlight: window.ft.outboundFlight || {},
								returnFlight: window.ft.returnFlight || {},
								isRoundTrip: window.ft.isRoundTrip,
								passengers: window.ft.passengerList,
								contacts: window.ft.contactList
							}),
							status: 'PAID',
							createdTime: new Date().format("yyyy-MM-dd hh:mm:ss")
						};
						window.ft.orderJS.store(window.ft.orderInfo);
						
						WL.SimpleDialog.show("Success","Book ticket success",[{text:'OK',handler:function(){
							var para = {flightSegmentId:$('#OFInfoOR .flightSegmentId').text()};
							var invocationData = {
									adapter : "FTAdapter",
									procedure : "HotelREST_getHotelsByFlighSegmentId",
									parameters : [para,window.ft.cookies]
								};
							WL.Client.invokeProcedure(invocationData, {
								onSuccess: function(resp) {
									if (resp.invocationResult.array[0].result) {
										window.ft.hotelList = resp.invocationResult.array[0].result;
										$('#topTitle .city').html(resp.invocationResult.array[0].result[0].address.city);
										var props = ['name', 'price','star','rating'];
										$.each(resp.invocationResult.array[0].result, function(i, hotel) {
											var $tempItem = $('#topHotelList .template' + i);
											if(!hotel.booked){
												$('.bookBefore', $tempItem).hide();
											}else{
												$('.bookBefore', $tempItem).show();
											}
											if(!hotel.favorite){
												$('.favorite', $tempItem).hide();
											}
											$tempItem.attr('hotelId',hotel.id);
											$.each(props, function(i, prop) {
												if('star'==prop){
													var $starRating = $('.starRating', $tempItem).html('');
													for(var i = 0; i < hotel.star; i++) {
														$starRating.append('<span class="smallstar">');
													}
												}else{
													if ('name' == prop) {
														hotel[prop] = hotel[prop].split(" ", 1)
																+ " hotel";
													}else if('price' == prop) {
														hotel[prop] = '$' + hotel[prop].amount;
													}
													$('.' + prop, $tempItem).html(hotel[prop]);
												}
												
											});
										});
									    $('#bookHotelPopup').popup('open');
									}
								},
								onFailure: function(resp) {
									console.log("invoke FTAdapter failed: " + resp);
								}
							});
						}}]);
				
					}else{
						busy.hide();
						alert("Sorry, your order has not been created.");
					}
				}
			});
		});
		
		$('#topHotelList').on('tap', '.hotel', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
//			var hotelName = $('.name', $(this)).text();
			window.ft.hotelDetailId = $(this).attr('hotelId');
			//workaround for pop up next time
			$('#bookHotelPopup').popup("close");
			setTimeout(function() {
				window.ft.isFromPopup = true;
				$.mobile.changePage('hotelDetails.html');
			}, 500);
		}).on('vmousedown', '.hotel', function(e) {
			var $target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.hotel', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		$('#searchHotelBtn').on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			$('#bookHotelPopup').popup("close");
			setTimeout(function() {
				$.mobile.changePage('hotelAssist.html');
			}, 500);
		});
		
		$('#closePopupBtn').on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			$('#bookHotelPopup').popup("close");
			setTimeout(function() {
				$.mobile.changePage('order.html');
			}, 500);
		});
		
	});
})(jq);