/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	function renderFlightList() {
		$('#returnFlightList').html($('#returnFlightList .template'));
		if(!window.ft.returnFlightList || window.ft.returnFlightList.length == 0) {
			$('#returnFlightList .template.noReturnFlights').show();
		} else {
			$('#returnFlightList .template.noReturnFlights').hide();
			
			var props = ['departTime', 'reachTime', 'price', 'seats','flightSegmentId','airplaneTypeId'];
			$.each(window.ft.returnFlightList, function(i, flight) {
				var $itemFlight = $('#returnFlightList .template.returnFlight').clone();
				$.each(props, function(i, prop) {
					var value = flight[prop];
					if(prop == 'price') {
						value = '$' + value;
					}
					if(-1 != prop.indexOf('Time') && typeof(value) !== 'string'){
						value = (new Date(value)).format('hh:mm');
						flight[prop] = value;
					}
					$('.' + prop, $itemFlight).text(value);
				});
				$itemFlight.removeClass('template')
					.attr('data-flight-index', i).appendTo('#returnFlightList').show();
			});
		}
		$('#returnFlightList').listview('refresh');
	}
	
	function formatDate(aDate) {
//		var date = aDate.toISOString();
//		return date.substring(0, date.indexOf('T'));
		var m = aDate.getMonth() + 1;
		var d = aDate.getDate();
		return aDate.getFullYear() + '-' +
			(m < 10 ? '0' + m : m) + '-' + (d < 10 ? '0' + d : d);
	}
	
	function displayDate(date) {
		$.each({
			'dayOfWeek': DAYS_OF_WEEK_SHORT[date.getDay()],
			'day': date.getDate(),
			'month': MONTHS_OF_YEAR[date.getMonth()],
			'year': date.getFullYear()
		}, function(prop, value) {
			$('.flight-date .departDate .' + prop, $('#selectReturnFlightPage')).text(value);
		});
	}
	
	$("#selectReturnFlightPage").live("pagebeforeshow", function() {
		var $this = $(this);
		var returnDate = new Date(Date.parse(window.ft.returnDate.replace(/-/g, '/')));
		$.each({
			'dayOfWeek': DAYS_OF_WEEK_SHORT[returnDate.getDay()],
			'day': returnDate.getDate(),
			'month': MONTHS_OF_YEAR[returnDate.getMonth()],
			'year': returnDate.getFullYear()
		}, function(prop, value) {
			$('.flight-date .departDate .' + prop, $this).text(value);
		});
		
		$('.depart-airport .departAP', $this).text(window.ft.destAP);
		$('.dest-airport .destAP', $this).text(window.ft.departAP);
		
//		$('#RFDepartDestAP').text(window.ft.destAP + ' to ' + window.ft.departAP);
//		$('#RFDepartDate').text(window.ft.returnDate);
		renderFlightList();
	});
	
	$("#selectReturnFlightPage").live("pageinit", function() {
//		ft.util.decorateButtons("#selectReturnFlightPage .backBtn");
		
		$('#returnFlightList').on('tap', '.returnFlight', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			var idx = $(this).attr('data-flight-index');
			window.ft.returnFlight = window.ft.returnFlightList[idx];
			$.mobile.changePage('bookTicket.html');
		}).on('vmousedown', '.returnFlight', function(e) {
			$target = $(this).closest('li');
			$target.addClass('ui-btn-active');
			window.ft.$activeLinks.push($target);
		}).on('vmousemove', '.returnFlight', function(e) {
			$(this).closest('li').removeClass('ui-btn-active');
		});
		
		$('.prev-btn, .next-btn', $(this)).on('tap', function(e) {
			var isNext = $(this).hasClass('next-btn');
			busy.show();
			wait(1, function() {
				var date = new Date(window.ft.returnDate.replace(/-/g, '/'));
                date.setDate(date.getDate() + (isNext ? 1 : -1));
                displayDate(date);
				window.ft.returnDate = date.format('yyyy-MM-dd');
				
				var queryParams = $.extend({}, window.ft.flightQueryParams, {
					fromDate: date.setHours(0,0,0,0)
				});
				searchFlights(function(resp) {
					console.log(resp);
					window.ft.returnFlightList = parseResult(resp.invocationResult.flightList, true);
					renderFlightList();
					busy.hide();
				}, queryParams);
			});
			return false;
		});
		
		/*
		$('#RFPrevBtn, #RFNextBtn').on('click', function() {
			busy.show();
			var isNext = ($(this).attr('id') == 'RFNextBtn'); 
			wait(1, function() {
				var date = new Date(window.ft.returnDate.replace(/-/g, '/'));
                date.setDate(date.getDate() + (isNext ? 1 : -1));
				window.ft.returnDate = date.format('yyyy-MM-dd');
				window.ft.flightQueryParams.returnDate = window.ft.returnDate;
				$('#RFDepartDate').text(window.ft.returnDate);
				
//				window.ft.flightQueryParams.isSearchingReturnFlight = true;
				searchFlights(function(resp) {
					console.log(resp);
					window.ft.returnFlightList = resp.invocationResult.flightList;
					renderFlightList();
					$('#RFPrevBtn, #RFNextBtn').removeClass('ui-btn-active');
					busy.hide();
				});
			});
			return false;
		});
		*/
	});
})(jq);