/*
 * Licensed Materials - Property of IBM
 * 5725-G92 (C) Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function($) {
	$("#selectSeatPage").live("pagebeforeshow", function() {
		window.ft.seatNo = '';
		$('#seats .selected').removeClass('selected');
		WL.Client.invokeProcedure({
			adapter : "LoginAdapter",
			procedure : "getBookedSeatNo"
		}, {
			onSuccess: function(resp) {
				$('#seats .seat.booked').removeClass('booked');
				var bookedSeatNo = resp.invocationResult.bookedSeatNo;
				bookedSeatNo = bookedSeatNo.split(',');
				$.each(bookedSeatNo, function(i, sn) {
					$('#' + sn).addClass('booked');
				});
			}
		});
	});
	
	$("#selectSeatPage").live("pageinit", function() {
		$('#seats').on('tap', '.seat', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			
			var $this = $(this);
			if($this.hasClass('booked')) {
				$('#warning .message').text('This seat is booked, please choose another one.');
                $('#warning').popup('open', {
                	transition: (isIOS() ? 'pop' : 'none')
                });
			} else if($this.hasClass('selected')) {
				$this.removeClass('selected');
				window.ft.seatNo = '';
			} else {
				$('#seats .selected').removeClass('selected');
				$this.addClass('selected');
				var pos = $this.position();
				$('#seatInfo').text('You selected seat: ' + $this.attr('id')).popup('open', {
					transition: (isIOS() ? 'pop' : 'none'),
					x: pos.left,
					y: (pos.top - 30) 
				});
				window.ft.seatNo = $this.attr('id');
			}
		});
		
		$('#okBtn').on('tap', function(e) {
			e.stopImmediatePropagation();
			e.preventDefault();
			$('#warning').popup('close');
		});
		
//		ft.util.decorateButtons("#selectSeatPage .backBtn");
		
		linkBD('#selectSeatPage .nextBtn', 'boardingPass.html', {
			onBeforeChange: function() {
				if(!window.ft.seatNo) {
					$('#warning .message').text('Please select your seat before next step.');
	                $('#warning').popup('open', {
	                	transition: (isIOS() ? 'pop' : 'none'),
	                });
	                return false;
				} else {
					// change the order status to CHECKED-IN
					window.ft.orderJS.find({ id: window.ft.order.id }, {
						onSuccess: function(data) {
							var order = data[0];
							order.json.status = 'CHECKED-IN';
							window.ft.orderJS.replace(order, {
								onFailure: failureJS
							});
						},
						onFailure: failureJS
					});
				}
			}
		});
		
		var $vacantSeat = $('#seats .templete.vacant')
			.clone().removeClass('templete').css('display', 'inline-block');
		var $corridor = $('#seats .templete.corridor')
			.clone().removeClass('templete').css('display', 'inline-block');
		var $seats = $('#seats').html($('#seats .templete'));
		
		var chcode = 'A'.charCodeAt(0);
		for(var r = 0; r < 30; r++) {
			for(var c = 0; c < 6; c++) {
				var seatNo = (r + 1) + String.fromCharCode(chcode + c);
				if(c == 3) {
					$corridor.clone().appendTo($seats);
				}
				$vacantSeat.clone().attr('id', seatNo).appendTo($seats);
			}
			$seats.append('<br/>');
		}
	});
})(jq);